<template>
  <v-container>
    <v-row>
      <v-col>
        <v-card elevation="0">
          <v-toolbar density="compact" color="#072AC8">
            <v-spacer />
            <v-btn icon @click="__onToggleTheme">
              <v-icon>mdi-theme-light-dark</v-icon>
            </v-btn>
          </v-toolbar>
          <v-card-text>
            <v-row justify="center">
              <v-col cols="8">
                <v-text-field
                  class="mt-5"
                  placeholder="Busqueda"
                  prepend-icon="mdi-map-search"
                  variant="outlined"
                  density="comfortable"
                  v-model="sBusqueda"
                  @click:clear="sBusqueda = ''"
                  clearable
                />
              </v-col>
            </v-row>
            <v-row v-if="cmp_items.length !== 0">
              <v-col v-for="(item, index) in cmp_items" :key="index" cols="2">
                <Pokemon :pokemon="item" />
              </v-col>
            </v-row>
            <v-row v-else justify="center">
              <v-col cols="4">
                <div class="d-flex justify-center">
                  <img src="/images/psyduck.png" width="120"/>
                </div>
                <div class="d-flex justify-center">
                  <p>
                    No se ha encontrado información
                  </p>
                </div>
              </v-col>
            </v-row>
            <v-row v-if="loading">
              <v-col> Cargando... </v-col>
            </v-row>
          </v-card-text>
        </v-card>
        <div class="text-center">
          <v-pagination
            v-model="page"
            :length="4"
            prev-icon="mdi-menu-left"
            next-icon="mdi-menu-right"
          />
        </div>
      </v-col>
    </v-row>
    
  </v-container>
</template>
<script setup>
import { computed, onMounted, ref, watch } from "vue";
import { useTheme } from "vuetify";
import axios from "axios";

import Pokemon from "@/components/Pokemon.vue";

const theme = useTheme();
const items = ref([]);
const loading = ref(false);
const sBusqueda = ref("");
const limit = ref(15)
const offset = ref(0)
const page = ref(1)
onMounted(() => onGetItems());
const onGetItems = async () => {
  try {
    loading.value = true;
    const { data: { results } } = await axios.get(`pokemon?limit=${limit.value}&offset=${offset.value}`);
    await Promise.all(
      results.map(async (oItem) => {
        const { data } = await axios.get(`pokemon/${oItem.name}`);
        oItem.cover = data.sprites.other.dream_world.front_default;
        oItem.details = data;
      })
    );

    items.value = results;
    loading.value = false;
  } catch (error) {
    loading.value = false;
  }
};

watch(() => page.value, () => {
  limit.value = page.value*limit.value;
  offset.value = limit.value+30

  onGetItems()
})

// Esta computada retorna la información filtrada
const cmp_items = computed(() => {
  if (sBusqueda.value === "") return items.value;
  else
    return items.value.filter((item) =>
      item?.name?.toLowerCase().includes(sBusqueda.value.toLowerCase())
    );
});
const __onToggleTheme = () => {
  theme.global.name.value = theme.global.current.value.dark ? "light" : "dark";
};
</script>